// Copyright 2010 two forty four a.m. LLC <http://www.twofortyfouram.com>
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at <http://www.apache.org/licenses/LICENSE-2.0>
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package com.twofortyfouram.locale;

/**
 * Utility class containing constants for the <i>Locale</i> Developer Platform
 */
/*
 * This class is NOT part of the public API
 */
final class Constants
{

	/**
	 * Log tag for logcat messages generated by the <i>Locale</i> Developer Platform
	 */
	/*
	 * This is NOT a public field. Third party apps should NOT use this log tag for their own log messages
	 */
	static final String LOG_TAG = "Locale"; //$NON-NLS-1$

	/**
	 * String package name for <i>Locale</i>
	 */
	/*
	 * This is NOT a public field. Third party should NOT rely on this being the only package name for Locale
	 */
	static final String LOCALE_PACKAGE = "com.twofortyfouram.locale"; //$NON-NLS-1$
}
